package dev.fyloz.colorrecipesexplorer.model

/** Represents an entity, named differently to prevent conflicts with the JPA annotation. */
interface ModelEntity {
    val id: Long?
}

interface NamedModelEntity : ModelEntity {
    val name: String
}

interface EntityDto<out E> {
    /** Converts the dto to an actual entity. */
    fun toEntity(): E {
        throw UnsupportedOperationException()
    }
}

// GENERAL VALIDATION MESSAGES
const val VALIDATION_SIZE_GE_ZERO = "Must be greater or equals to 0"
const val VALIDATION_SIZE_GE_ONE = "Must be greater or equals to 1"
const val VALIDATION_RANGE_PERCENTS = "Must be between 0 and 100"
