package dev.fyloz.colorrecipesexplorer.repository

import dev.fyloz.colorrecipesexplorer.model.Company
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Query
import org.springframework.stereotype.Repository

@Repository
interface CompanyRepository : JpaRepository<Company, Long> {
    /** Checks if a company with the given [name] and a different [id] exists. */
    fun existsByNameAndIdNot(name: String, id: Long): Boolean

    /** Checks if a recipe depends on the company with the given [id]. */
    @Query(
        """
        select case when(count(r) > 0) then true else false end 
        from Recipe r where r.company.id = :id
        """
    )
    fun isUsedByRecipe(id: Long): Boolean
}
